widget_quintupoltrobol/announcements/urls.py
from django.urls import path
from .views import pageview, AnnouncementDetailView, AnnouncementCreateView, AnnouncementEditView

urlpatterns = [
    path('', pageview, name='pageview'),
    path('<int:pk>/details/', AnnouncementDetailView.as_view(), name="announcement_details"),
    path('add/', AnnouncementCreateView.as_view(), name='announcement_add'),
    path('<int:pk>/edit/', AnnouncementEditView.as_view(), name='announcement_edit'),
]

app_name = "announcements"

widget_quintupoltrobol/forum/urls.py
from django.urls import path
from .views import pageview, ForumpostDetailView, ForumpostCreateView, ForumpostUpdateView

urlpatterns = [
    path('', pageview, name='pageview'),
    path('forumposts/<int:pk>/details/', ForumpostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add/', ForumpostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit/', ForumpostUpdateView.as_view(), name='forumpost-edit'),
]

app_name = "forum"

widget_quintupoltrobol/widget_quintupoltrobol/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('widget_calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('admin/', admin.site.urls),
]

widget_quintupoltrobol/announcements/models.py
from django.db import models
from dashboard.models import WidgetUser
from django.urls import reverse
from django.utils import timezone

class Announcement(models.Model):
  title = models.CharField(max_length=50)
  body = models.TextField(max_length=1024)
  author = models.ForeignKey(WidgetUser, on_delete=models.CASCADE)
  pub_datetime = models.DateTimeField(default=timezone.now)

  def __str__(self):
    return self.title
  
  def get_absolute_url(self):
    return reverse("announcements:announcement_details", kwargs={"pk": self.pk})


class Reaction(models.Model):
  name_choices = [
        ("Like", 'Like'),
        ("Love", 'Love'), 
        ("Angry", 'Angry')
    ]
  name = models.CharField(
        max_length=10,
        choices=name_choices,
    )

  tally = models.IntegerField()
  announcement = models.ForeignKey(Announcement, on_delete=models.CASCADE)

  def __str__(self):
    return self.name

widget_quintupoltrobol/announcements/forms.py
from django import forms
from .models import Announcement

class AnnouncementForm(forms.ModelForm):
    class Meta:
        model = Announcement
        fields = ['title', 'body', 'author']

widget_quintupoltrobol/announcements/views.py
from .forms import AnnouncementForm
from .models import Announcement, Reaction
from django.views.generic import ListView, DetailView, CreateView, UpdateView
from django.db.models import Sum
from django.shortcuts import render
from django.urls import reverse
from .models import Announcement

def pageview(request):
    model_object = Announcement.objects.order_by("-pub_datetime")
    return render(request, "announcements/announcements.html", context={"announcement_list":model_object})


class AnnouncementListView(ListView):
    model = Announcement
    template_name = "announcements/announcements.html"

class AnnouncementDetailView(DetailView):
    model = Announcement
    template_name = "announcements/announcement-detail.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        reactions = Reaction.objects.filter(announcement=self.object)

        context['like_count'] = reactions.filter(name='Like').aggregate(total=Sum('tally'))['total'] or 0
        context['love_count'] = reactions.filter(name='Love').aggregate(total=Sum('tally'))['total'] or 0
        context['angry_count'] = reactions.filter(name='Angry').aggregate(total=Sum('tally'))['total'] or 0
        return context

class AnnouncementCreateView(CreateView):
    model = Announcement
    form_class = AnnouncementForm
    template_name = "announcements/announcement-add.html"

    def get_success_url(self):
        return reverse("announcements:announcement_details", kwargs={"pk": self.object.pk})
    
class AnnouncementEditView(UpdateView):
    model = Announcement
    form_class = AnnouncementForm
    template_name = "announcements/announcement-edit.html"

    def get_success_url(self):
        return reverse("announcements:announcement_details", kwargs={"pk": self.object.pk})

widget_quintupoltrobol/announcements/templates/announcements/announcement-add.html
{% extends "base.html" %}
{% load static %}
{% block title %}
Add Announcement
{% endblock %}

{% block content %}
<h2>Add a new announcement:</h2>

<p>
  <form action="" method="post">
    {% csrf_token %}
    <table>
      {{ form.as_table }}
    </table>
    <input type="submit" value="Add Announcement"/>
  </form>
</p>

{% endblock %}

widget_quintupoltrobol/announcements/templates/announcements/announcement-detail.html
{% extends "base.html" %}

{% block title %}
{{object.title}}
{% endblock %}

{% block content %}
<h2>{{object.title}}</h2>
<h3> by {{object.author.first_name}} {{object.author.last_name}}</h3>
<p>{{object.pub_datetime}}</p> 
<br>
<p>{{object.body}}</p>
<br>
<p>Like: {{like_count}} <br><br>
Love: {{love_count}} <br><br>
Angry: {{angry_count}}</p>
<br>
<button> <a href="{% url 'announcements:announcement_edit' object.pk %}">Edit Announcement</a></button>

{% endblock %}

widget_quintupoltrobol/announcements/templates/announcements/announcement-edit.html
{% extends 'base.html' %}
{% load static %}
{% block title %} Edit Announcement {% endblock %}
{% block content %}
  <h2>Edit announcement:</h2>
  <div class="form">
    <form action="" method="post">
      {% csrf_token %}
      <table>
        {{ form.as_table }}
      </table>
      <input type="submit" value="Save Changes to Announcement" />
    </form>
  </div>
  
{% endblock %}

widget_quintupoltrobol/announcements/templates/announcements/announcements.html
{% extends "base.html" %}
{% load static %}
{% block title %}
Widget's Announcement Board
{% endblock %}

{% block content %}
<h2>Welcome to Widget's Announcement Board!</h2>
<h3>Announcements:</h3>


  {% for object in announcement_list %}
  <p>
  <a href="{{object.get_absolute_url}}">{{object.title}} by {{object.author.first_name}} {{object.author.last_name}}</a>
  </p>
  {% endfor %}
<br>
<button type="button"><a href="{% url 'announcements:announcement_add' %}"> New Announcement </a></button><br><br>
<a href="{% url 'dashboard:pageview' %}">Dashboard</a><br>
<a href="{% url 'forum:pageview' %}">Forum</a><br>
<a href="{% url 'assignments:pageview' %}">Assignment</a><br>
<a href="{% url 'widget_calendar:pageview' %}">Calendar</a><br>

{% endblock %}